import java.sql.*;
import java.util.*;
import java.util.regex.*;
import java.sql.*;
import bitel.billing.server.util.*;
import bitel.billing.server.contract.bean.*;
import bitel.billing.common.*;

getWherePart( filter, pageSize, pageIndex )
{
	status = filter.getIntParam( "status" );
	cityID = filter.getIntParam( "cityId" );
	streetID = filter.getIntParam( "streetId" );
	house = filter.getIntParam( "house" );	
	

	String query = " WHERE 1=1 ";	
	
	if (status >= 0)
	{
		query += " AND contract.status = " + status ; 									
	}
	
	if ( cityID > 0)
	{
		query += " AND house.cityId =  " + cityID; 	
	}

	if ( streetID > 0 )
	{
		query += " AND house.streetId = " + streetID;
	}

	if ( house > 0 )
	{
		query += " AND house.house = " + house;
	}

	return query;
}

getFromPart( filter )
{
	phonePid = filter.getIntParam( "report.contract_csv_list.phone.pid", 1 );
	addressPid = filter.getIntParam( "report.contract_csv_list.address.pid", 3 );
	
	query = 	" FROM contract " +
   							" LEFT JOIN contract_parameter_type_1 as phone ON contract.id=phone.cid" +
                  			" AND phone.pid=" +  phonePid +
							" LEFT JOIN contract_parameter_type_2 as address ON contract.id=address.cid" + 
							" AND address.pid=" +  addressPid +
							" LEFT JOIN contract_tariff  on contract_tariff.cid = contract.id AND (contract_tariff.date1 <= ? OR contract_tariff.date1 is NULL)  AND " +
							" (contract_tariff.date2 >= ? OR contract_tariff.date2 is NULL) " +  
							" LEFT JOIN tariff_plan  on contract_tariff.tpid= tariff_plan.id" +
				   			" LEFT JOIN address_house as house ON house.id=address.hid" +
							" LEFT JOIN temp_balance  ON temp_balance.cid=contract.id " +								 					
							" LEFT JOIN contract_balance as b  ON b.cid=contract.id AND  b.mm = temp_balance.mm AND b.yy = temp_balance.yy";
	return query;

}

addStatements( ps )
{
	Calendar currentCal = new GregorianCalendar();	
	java.sql.Date current = new java.sql.Date( currentCal.getTime().getTime() );

	for ( int i = 1; i <= 2; i++)
	{
		ps.setDate(i, current );
	}

}

public void fillReport( con, filter, bitel.billing.server.reports.BGCSVReport.ReportResult result, pageSize, pageIndex )
{	

	query = "DROP TABLE IF EXISTS temp_balance;";  	
	con.createStatement().executeUpdate( query );

	query =
            "CREATE  TEMPORARY TABLE temp_balance ( UNIQUE(cid) ) " +
            "SELECT cid, MAX(yy*12+(mm-1))%12 + 1 AS mm," +
            "FLOOR(MAX(yy*12+(mm-1)) / 12) AS yy " + 
            "FROM contract_balance GROUP BY cid";        
            
    	con.createStatement().executeUpdate( query );


	
	time = System.currentTimeMillis();
	
	query = "SELECT contract.title, contract.comment, address.address,  phone.val as phone_number, contract.status, " +
							" tariff_plan.title as tariff, " +
							" (b.summa1 + b.summa2 - b.summa3 - b.summa4) as balance ";
	query += getFromPart( filter );
	query += getWherePart(filter, pageSize, pageIndex);
				
	query +=  " ORDER BY contract.title ";
	query += " LIMIT " + ((pageIndex - 1) * pageSize )+ "," + pageSize;
		
	
	System.out.println( query );	


	ps = con.prepareStatement( query );
	addStatements ( ps );
	


	data = new ArrayList( 1000 );

	rs = ps.executeQuery();
	System.out.println( "getting results" );	
	while( rs. next() )
	{
		title = rs.getString("title");
		comment = rs.getString("comment"); 			
		address = rs.getString("address");
		phone = rs.getString("phone_number");
		balance = rs.getDouble("balance");
		st = rs.getInt("status");
		tariff = rs.getString("tariff");
		
	


		map = new HashMap();
		map.put( "title", title );
		map.put( "comment", comment );
		map.put( "address", address );
		map.put( "phone", phone );
		map.put( "balance", balance.toString() );
		map.put( "status", ContractStatus.statusToString( st ) );
		map.put( "tariff", tariff);


		data.add( map );
	}

	result.setData( data );

	query = "SELECT COUNT(*) from contract ";
	ps = con.prepareStatement( query );
	query += getFromPart( filter );
	query += getWherePart(filter, pageSize, pageIndex);

	System.out.println( query );	
	
	//addStatements ( ps );
	rs = ps.executeQuery();
	
	if ( rs. next() )
	{
		System.out.println( "found=" + rs.getInt(1) );			
		result.setCount( rs.getInt(1) );
	}	
	
	
}
